BEGIN { push(@INC, ".."); };
use WebminCore;
use DBI;

&init_config();
%access = &get_module_acl();

sub get_stats {
	my $username=$config{'db_account'};
	my $password=$config{'db_account_pass'};
	my $database=$config{'db_name'};
	my $hostname=$config{'db_hostname'};

	my @metrics;

	my $dbh = DBI->connect("dbi:Pg:dbname=$database;host=$hostname;",
				$username,$password) 
				or return @metrics = ("1ERR","Could Not Connect to Database. Make sure the connection string is in module config located in the top left corner of this window");
	
	my $selsth = $dbh->prepare("SELECT procpid,usename,current_query,query_start,client_addr 
					FROM pg_stat_activity
					WHERE substr(current_query,1,36) <> 'SELECT procpid,usename,current_query';"); 
	$selsth->execute();

	while ( my ($procpid,$usename,$cquery,$qstart,$cip) = $selsth->fetchrow_array ) {
        	if ($cquery eq '<IDLE>') {
			$cquery = "Idle";
		}
		push(@metrics,"$procpid:SRAD:$usename:SRAD:$cquery:SRAD:$qstart:SRAD:$cip");
	}

	$selsth->finish();

	$dbh->disconnect();

	return @metrics;
}

sub kill_proc {
	my $username=$config{'db_account'};
        my $password=$config{'db_account_pass'};
        my $database=$config{'db_name'};
        my $hostname=$config{'db_hostname'};
        my $procpid = $_[0];

        my $dbh = DBI->connect("dbi:Pg:dbname=$database;host=$hostname;",
                                $username,$password,{ RaiseError =>1 })
                                or die ("Could Not Connect to Database");

        my $dsth;

        $dsth = "select pg_terminate_backend($procpid)";

        my $result = $dbh->do($dsth) or die ("Can't execute $stmt: $dbh->errstr\n");
        $dbh->disconnect();

	if ($DBI::err) {
		return 1;
	} else {
		return 0;
	}
}

1;
