#!/usr/bin/perl
# cgcsvcs.cgi
# Display cgconfig service status by host

require 'cgroupsmgmt-lib.pl';
&ReadParse();

my $mode = $in{'mode'};
my $cgcstart = $in{'cgcfgstart'};
my $cgcstop = $in{'cgcfgstop'};

int($cgcstart);
int($cgcstop);

if (($mode eq "") or ($cgcstart eq "") or ($cgcstop eq "")) {
	&ui_print_header(undef, $text{'cgcsvcs_title'}, undef, undef, 0, 1, 0);
	print $text{'cgcsvcs_nodirect'};
	&ui_print_footer("/cgroups", $text{'index_title'});
	exit;
}

if (($cgcstart == 0) and ($mode eq "start")) {
	&ui_print_header(undef, $text{'cgcsvcs_title'}, undef, undef, 0, 1, 0);
	print $text{'cgcsvcs_nostart'};
	&ui_print_footer("/cgroups", $text{'index_title'});
	exit;
} 
 
if (($cgcstop == 0) and ($mode eq "stop")) {
	&ui_print_header(undef, $text{'cgcsvcs_title'}, undef, undef, 0, 1, 0);
	print $text{'cgcsvcs_nostop'};
	&ui_print_footer("/cgroups", $text{'index_title'});
	exit;
}

&ui_print_header(undef, $text{'cgcsvcs_title'}, undef, undef, 0, 1, 0);

my @cgcfgchk = &svcs_status("cgconfig");

print &ui_form_start("process_asvcs.cgi", "post");

        my @links = (&select_all_link("d"),&select_invert_link("d"));
        my @tds =("style=\"white-space: nowrap; padding: 5px;\"",
                  "style=\"white-space: nowrap; padding: 5px;\"",
                  "style=\"white-space: nowrap; padding: 5px;\"",
                  "style=\"white-space: nowrap; padding: 5px;\"");

        print &ui_links_row(\@links);

        print &ui_columns_start([undef,
                                $text{'allsvcs_hostname'},
                                $text{'allsvcs_service'},
                                $text{'allsvcs_status'}],undef,0);

	my $s = "cgconfig";
	my $stat;
	my $estat;

        foreach my $line (sort @cgcfgchk) {
                chomp($line);
                my ($h,$e,undef) = split(":", $line);
                int($e);

                if ($e > 0) {
                        $stat = $text{'allsvcs_nosvc'};
                	$estat = "Stopped";
		} elsif ($e == 0) {
                        $stat = $text{'allsvcs_ysvcs'};
                	$estat = "Started";
		}

		if (($mode eq "stop") && ($estat eq "Stopped")) {
                	print &ui_columns_row([&ui_checkbox("d","$h:$s",undef,0),$h,$s,$stat],\@tds);
        		next;
		} elsif (($mode eq "start") && ($estat eq "Started")) {
                	print &ui_columns_row([&ui_checkbox("d","$h:$s",undef,0),$h,$s,$stat],\@tds);
		}
	}
        print &ui_columns_end();
        if ($mode eq "stop") {
		print &ui_form_end([[ "start", $text{'allsvcs_start'} ],
                	            [ "restart", $text{'allsvcs_restart'} ]]);
	} elsif ($mode eq "start") {
		print &ui_form_end([[ "stop", $text{'allsvcs_stop'} ],
                	            [ "restart", $text{'allsvcs_restart'} ]]);
	}

&ui_print_footer("/cgroups", $text{'index_title'});
