#!/usr/bin/perl
# index.cgi
# Display Landing Page for CGroups Module

require 'cgroupsmgmt-lib.pl';

$libcgcheck = `which cgconfigparser`;
chomp($libcgcheck);
 
if ( ! -e $libcgcheck ) {
	&ui_print_header(undef, $text{'newgrp_errtitle'}, undef, undef, 0, 1, 0);
	print &text('index_nolibcgrp') . "<br>\n";
	&ui_print_footer("/cgroups", $text{'index_title'});
	exit;
}

my @tds = ("bgcolor=#ffffff","bgcolor=#ffffff","bgcolor=#ffffff");
my %cgroups = &parse_cgroups();
my ($ucpu,$acpu,$cmax) = split(":", &get_cpustats());


&ui_print_header(undef, $text{'index_title'}, undef, undef, 0, 1, 0);
print &ui_subheading("<b>$text{'cgroups_svcs'}</b> <font size=-1><a href=\"allsvcs.cgi\">$text{'cgroups_asvcs'}</a></font>");
print "<br>\n";


my @cgcfgchk = &svcs_status("cgconfig");
my $rcgc = 0;
my $scgc = 0;

foreach my $line (@cgcfgchk) {
	chomp($line);
	my ($host,$err,undef) = split(":", $line);
	int($err);
	if ($err > 0) {
		$scgc++;
	} else {
		$rcgc++;
	}
}

print &ui_columns_start(undef,undef,1);
print &ui_columns_row(["<b>cgconfig:</b>",
	"<a href=\"cgcsvcs.cgi?mode=start&cgcfgstart=$rcgc&cgcfgstop=$scgc\">$rcgc $text{'cgroups_start'}</a>",
	",<a href=\"cgcsvcs.cgi?mode=stop&cgcfgstart=$rcgc&cgcfgstop=$scgc\">$scgc $text{'cgroups_stop'}</a>"],\@tds);  
print &ui_columns_end();
print "<br>\n";

my @tds2 =("style=\"white-space: nowrap\"",
           "style=\"white-space: nowrap\"",
           "style=\"white-space: nowrap\"",
           "style=\"white-space: nowrap\"",
           "style=\"white-space: nowrap\"");

print &ui_subheading("<b>$text{'cgroups_act'}</b> <font size=-1><a href=\"newgroup.cgi\">$text{'group_newgrp'}</a></font>");
print "<br>\n";
if (keys %cgroups) {
	print &ui_form_start("del_cgroups.cgi", "post");
	my @links = (&select_all_link("d"),&select_invert_link("d"));
        print &ui_links_row(\@links);
	print &ui_columns_start([undef,
			 $text{'cgroups_group'},
                         $text{'cgroups_desc'},
                         $text{'cgroups_subsys'}],60,0,\@tds2);

	foreach $key (sort(keys %cgroups)) {
		my ($desc,$subsys,$subv,$usrs,$ausers) = split("\0", $cgroups{$key});        
		$subsys =~ s/NULL,|,NULL//g;
		print &ui_columns_row([&ui_checkbox("d","$key",undef,0),"<a href=\"edit_cgroup.cgi?ecgroup=$key\">$key</a>",
		$desc,$subsys],@tds2);
	}
	print &ui_columns_end();
        print &ui_links_row(\@links);
	print &ui_form_end([[ "start", $text{'delgrp_del'} ]]);
} else {
	print "$text{'group_nogrps'}<br><br>\n";
}

print &ui_subheading("<b>$text{'cgroups_resall'}</b>");
print "<br>\n";
print &ui_columns_start([undef,
			$text{'res_used'},
			$text{'res_avail'},
			$text{'res_max'}],60,0,\@tds2);
print &ui_columns_row([$text{'res_cpusub'},$ucpu,$acpu,$cmax],\@tds2);
print &ui_columns_end();
&ui_table_start();
print "<br>\n";
print &ui_subheading("<b>$text{'cgroups_adm'}</b>");
print "<br>\n";
print &ui_form_start("admfunctions.cgi", "post");
print &ui_form_end([[ "comp", $text{'adm_comp'}],
		    [ "rcpy", $text{'adm_rcpy'}], 
		    [ "rsrt", $text{'adm_rsrt'}]]);
&ui_print_footer("/", $text{'index'});
