#!/usr/bin/perl
# process_newgrp.cgi
# Process actions from service administration related pages

require 'cgroupsmgmt-lib.pl';
&ReadParse();
my ($ucpu,$acpu,undef) = split(":", &get_cpustats());
my %cgfile = &parse_cgroups();
my %manusers = &get_managedusers();

my $gname = $in{'gname'};
my $gdesc = $in{'gdesc'};
my $cpushr = $in{'cpushr'};
my $amems = $in{'amems'};

chomp($gname);
chomp($gdesc);
chomp($cpushr);

if ($cpushr eq "") {
	$cpushr = "NULL";
}

if ($cgfile{$gname}) {
	&ui_print_header(undef, $text{'newgrp_errtitle'}, undef, undef, 0, 1, 0);
	print &text('newgrp_exists', $gname). "<br>\n";
	&ui_print_footer("/cgroups", $text{'index_title'});
	exit;
} elsif ($gname =~ / /) {
	&ui_print_header(undef, $text{'newgrp_errtitle'}, undef, undef, 0, 1, 0);
	print "$text{'newgrp_nospace'}<br>\n";
	&ui_print_footer("/cgroups", $text{'index_title'});
	exit;
} elsif ($gname !~ /^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9]*[A-Za-z0-9])$/) {
	&ui_print_header(undef, $text{'newgrp_errtitle'}, undef, undef, 0, 1, 0);
	print "$text{'newgrp_nascii'}<br>\n";
	&ui_print_footer("/cgroups", $text{'index_title'});
	exit;
}

if ($cpushr eq "NULL") {
        &ui_print_header(undef, $text{'newgrp_errtitle'}, undef, undef, 0, 1, 0);
        print "$text{'newgrp_nocandm'}<br>\n";
        &ui_print_footer("/cgroups", $text{'index_title'});
        exit;
}

if ($cpushr ne "NULL") {
	if ($cpushr > $acpu) {
		&ui_print_header(undef, $text{'newgrp_errtitle'}, undef, undef, 0, 1, 0);
		print &text('newgrp_bigcpu', $cpushr, $acpu) . "<br>\n";
		&ui_print_footer("/cgroups", $text{'index_title'});
		exit;
	}

	if (($cpushr <= 0) or ($cpushr > 100)) {
		&ui_print_header(undef, $text{'newgrp_errtitle'}, undef, undef, 0, 1, 0);
		print &text('newgrp_zcpu', $acpu) . "<br>\n";
		&ui_print_footer("/cgroups", $text{'index_title'});
		exit;
	}
}

my @admusrs = split("\n", $amems);
if (int(scalar(@admusrs)) > 1) {
        &ui_print_header(undef, $text{'newgrp_errtitle'}, undef, undef, 0, 1, 0);
        print &text('newgrp_admmany', $u) . "<br>\n";
        &ui_print_footer("/cgroups", $text{'index_title'});
        exit;
}

if ($amems eq "") {
	$amems="NULL";
}

$amems =~ s/\n/,/g;
$amems =~ s/\s//g;

my $gent = "$gname\0$gdesc\0cpu\0$cpushr\0$amems\n";

&ui_print_header(undef, $text{'newgrp_title'}, undef, undef, 0, 1, 0);
print &text('newgrp_addent', $gname) . "<br>\n";
my $addenterr = &add_gent("$gent");
if ($addenterr == 1) {
	print &text('newgrp_cferr', $gname) . "<br>\n";
	&webmin_log($text{'log_acgr'}, $gname, $text{'log_fail'}, \%in);
	&ui_print_footer("/cgroups", $text{'index_title'});
	exit;
} else {
	&webmin_log($text{'log_acgr'}, $gname, $text{'log_succ'}, \%in);
}

print "$text{'newgrp_done'}<br><br>\n";
print "$text{'newgrp_gencgfile'}<br>\n";
my $cgfgerr = &gen_cgconfigf();
if ($cgfgerr == 1) {
        print &text('newgrp_copengroupsf') . "<br>\n";
        &ui_print_footer("/cgroups", $text{'index_title'});
        exit;
} elsif ($cgferr == 2) { 
        print &text('newgrp_copencgfile') . "<br>\n";
        &ui_print_footer("/cgroups", $text{'index_title'});
        exit;
}
print "$text{'newgrp_done'}<br><br>\n";
print "$text{'newgrp_propf'}<br>\n";
&prop_cfiles();
print "$text{'newgrp_done'}<br><br>\n";
print "$text{'newgrp_cgcompf'}<br>\n";
my %res = &compare_cgfiles();
if ($res{'err'} ne "") {
        print &text('newgrp_cgcomperr', $res{'err'}) . "<br>\n";
        &ui_print_footer("/cgroups", $text{'index_title'});
        exit;
} else {
	my $sum = "N";
	foreach my $keys (sort(keys %res)) {
		chomp($res{$keys});
		if ($sum eq "N") {
			$sum = $res{$keys};
		} elsif ($sum ne $res{$keys}) {
			print "&nbsp&nbsp&nbsp" . &text('newgrp_cghcomperr', $keys) . "<br>\n";
	       		&ui_print_footer("/cgroups", $text{'index_title'});
        		exit;
		}
	}
}
print "$text{'newgrp_done'}<br><br>\n";
print "$text{'newgrp_crcompf'}<br>\n";
print "$text{'newgrp_cgcsvcs'}<br>\n";
my @cgconfiga = &cgconfig_action("restart");
foreach my $line (sort(@cgconfiga)) {
	my ($h,$e,undef) = split(":", $line);
	int($e);
	if ($e > 0) {
		print &text('newgrp_cgcrerr', $h) . "<br>\n";
		&webmin_log($text{'log_cgrst'}, $text{'log_fail'}, $h, \%in);
	} 
}
&webmin_log($text{'log_cgrst'}, $text{'log_succ'}, $text{'log_all'}, \%in);
print "$text{'newgrp_done'}<br><br>\n";
&ui_print_footer("/cgroups", $text{'index_title'});
