#!/usr/bin/perl
use Time::Local;
require 'cubeclean-lib.pl';
&ReadParse();

my $mode = $in{'field'};
my $match = $in{'match'};
my $schstr = $in{'what'};
my $age = $in{'age'};
my $sday = $in{'dated'};
my $smon = $in{'datem'}-1;
my $syr = $in{'datey'};
my $now=time;
my $instRoot = $gconfig{'hpcmc_root'};
my $cfile="$instRoot/var/webmin/acubes";
my @csfiles;

&ui_print_header(undef, $text{'index_title'}, undef, undef, 1, 1, 0, undef);

open(ACFILE,"$cfile");
my @cfiles = (<ACFILE>);
close(ACFILE);

foreach my $line (@cfiles) {
	my $chk = 0;
	my ($h,$f,$o,$t) = split(",", $line);
	
	if (($h eq "") or ($f eq "") or ($o eq "") or ($t eq "")) {
		next;
	}
	
	if ($mode eq "user") {
		if ($match eq "contains") {
			if ( $o =~ /$schstr/ ) {
				$chk = 1;
			}			
		} elsif ($match eq "equals") {
			if ( $o eq "$schstr" ) {
				$chk = 1;
			}
		}
	}
	if ($mode eq "node") {
		if ($match eq "contains") {
			if ( $h =~ /$schstr/ ) {
				$chk = 1;
			}			
		} elsif ($match eq "equals") {
			if ( $h eq "$schstr" ) {
				$chk = 1;
			}
		}
	}
	if ($mode eq "filename") {
		my $cf = $f;
		$cf =~ s{.*/}{};
		if ($match eq "contains") {
			if ( $cf =~ /$schstr/ ) {
				$chk = 1;
			}			
		} elsif ($match eq "equals") {
			if ( $cf eq "$schstr" ) {
				$chk = 1;
			}
		}
	}
	if (($sday ne '') and ($smon ne '') and ($syr ne '') and ($chk == 0)) {
		my $setime = timelocal("59","59","23",$sday,$smon,$syr);
		if ( $age eq "older") {
			if ( $setime > $t ) {
				$chk = 1;
			}	
		} elsif ( $age eq "newer") {
			if ( $t > $age ) {
				$chk = 1;
			}
		}
	} elsif (($sday eq '') and ($smon ne '') and ($syr ne '')) {
		print &error($text{'search_noday'});
	} elsif (($sday ne '') and ($smon eq '') and ($syr ne '')) {
		print &error($text{'search_nomon'});
	} elsif (($sday ne '') and ($smon ne '') and ($syr eq '')) {
		print &error($text{'search_noyear'});
	}
		
	if ($chk == 1) {
		push(@csfiles, "$line\n" );
	}
}

if ( scalar(@csfiles) == 0 ) {
	print &error($text{'search_noresults'});
}	

print &ui_form_start("process_cubes.cgi", "post");
my @links = (&select_all_link("d"),&select_invert_link("d"));
my @tds =("style=\"white-space: nowrap\"",
	"style=\"white-space: nowrap\"",
	"style=\"white-space: nowrap\"",
	"style=\"white-space: nowrap\"",
	"style=\"white-space: nowrap\"");
print &ui_links_row(\@links);
print &ui_columns_start([undef,
			$text{'index_hostname'},
			$text{'index_filenametbl'},
			$text{'index_owner'},
			$text{'index_datetbl'}],undef,0);

foreach my $line (@csfiles) {
	chomp($line);
	my ($h,$f,$o,$t) = split(",", $line);
	$f =~ s/^ //g;
	$et = "EPOCHDATE$t";
	print &ui_columns_row([&ui_checkbox("d","$h:$f",undef,0),$h,$f,$o,$et],\@tds);
}

print &ui_columns_end();	
print &ui_form_end([[ "action", $text{'cube_com'} ]]);
&ui_print_footer("/cubeclean", $text{'index_name'});
