BEGIN { push(@INC, ".."); };
use WebminCore;

&init_config();
%access = &get_module_acl();

sub gfile_check() {
	if ( (-z "/etc/gridhosts") ) {
		return 0;
	} elsif ( -e "/etc/gridhosts" ) {
		return 1;
	} else {
		return 0;
	}
}

sub hostcon_check {
	my $hst = shift(@_);
	my $ret;
	system("ssh -q -o \"BatchMode=yes\" $hst echo");
	if ( $? == 0 ) {
		$ret = 0;
	} else {
		$ret = 1;
	}
	return $ret;
}

sub parse_hosts() {
	open(FILE,"/etc/hosts");
	my @hfile = (<FILE>);
	close(FILE);

	my @chfile = grep(/(sdw\d+\s)|(\smdw\s)/, @hfile);
	my @entries;

	foreach my $line (@chfile) {
        	$line =~ s/\s+/ /g;
        	$line =~ m/((sdw\d+\s)|(\smdw\s))/gi;
        	my $ent = $1;
        	$ent =~ s/\s+//g;
        	push(@entries,"$ent");
	}
	return @entries;
}

sub gen_gridhosts() {
	my @hosts = @_;
	open(FILE, ">/etc/gridhosts");
	foreach my $line ( @hosts ) {
		if ( $line =~ /^\n/ ) {
			next;
		}
		printf FILE "$line\n";
	}
	close(FILE);
}

sub get_hosts() {
	open(FILE, "/etc/gridhosts");
	@hosts = (<FILE>);
	close(FILE);
	@hosts = grep { $_ !~ /^\n/ } @hosts;
	return @hosts;
}

1;
