BEGIN { push(@INC, ".."); };
use WebminCore;
use Tie::File;

&init_config();
%access = &get_module_acl();

sub check_sfile {
	if ( -e "/etc/simgroups" ) {
		return 0;
	} else {
		return 1;	
	}
}

sub check_gfile {
	if ( -e "/etc/gridhosts" ) {
                return 0;
        } else {
                return 1;
        }
}

sub check_gname {
	my $gname = shift(@_);
	if ($gname !~ /^([A-Za-z]|[A-Za-z]*[A-Za-z0-9])$/) {
		return 1;
	}
	return 0;
}

sub get_sgroups {
	tie @sfile, 'Tie::File', "/etc/simgroups" or return 1;
	my %grps;
	foreach my $line (@sfile) {
		my ($grpname,$mems) = split("=", $line);
		$grps{$grpname} = $mems;
	}
	untie @sfile;
	return %grps;
}

sub get_sgmems {
	my $gname = shift @_;
	tie @sfile, 'Tie::File', "/etc/simgroups" or return 1;
	my %mems;
	foreach my $line (@sfile) {
		if ($line =~ /^$gname\=/) {
			chomp($line);
			my ($grpname,$membs) = split("\=", $line);
			$mems{'members'} = $membs;
		}
	}
	untie @sfile;
	return %mems;
}

sub get_fhosts {
	open(FHOSTS, "/etc/gridhosts");
	my @hfile = (<FHOSTS>);
	close(FHOSTS);
	my @ffile;
	foreach my $line (@hfile) {
		chomp($line);
		$line =~ s/\s+//g;
		push(@ffile, $line);
	}
	return @ffile;
}

sub get_fhostsh {
	open(FHOSTS, "/etc/gridhosts");
        my @hfile = (<FHOSTS>);
        close(FHOSTS);
        my @ffile;
        foreach my $line (@hfile) {
                chomp($line);
                $line =~ s/\s+//g;
                push(@ffile, { 'host' => $line});
        }
	return @ffile;
}

sub get_dedhosts {
	my %a = shift @_;
	my @b = shift @_;
	@b = grep $a{$_[0]}, @b;
	return @b;
}

sub add_sgroup {
	my $sgroup = shift;
	my %sgrp = %$sgroup;
	tie @sfile, 'Tie::File', "/etc/simgroups" or return 1;
	foreach my $key (keys %sgrp) {
		push(@sfile, "$key=$sgrp{$key}\n");
        	&webmin_log($text{'log_add'}, $text{'log_sgroup'}, $text{'log_success'}, \%sgrp);
	}
	untie @sfile;
	return 0;
}

sub del_sgroup {
	my $sgrp = shift(@_);
	tie @sfile, 'Tie::File', "/etc/simgroups" or return 1;
	@sfile = grep { ! /^$sgrp=/ } @sfile;
	untie @sfile;
	my %logent;
	$logent{$sgrp} = $sgrp;
        &webmin_log($text{'index_delete'}, $text{'log_sgroup'}, $text{'log_success'}, \%logent);
	return 0;
}

1;
