BEGIN { push(@INC, ".."); };
use WebminCore;
use Tie::File;

&init_config();
%access = &get_module_acl();

my $instRoot = $gconfig{'hpcmc_root'};

sub check_config {
	my @cfile;
	if ( -e "/etc/ssh/sshd_config" ) {
		open(CFILE,"/etc/ssh/sshd_config");
		@cfile = (<CFILE>);
		close(CFILE);
		foreach my $line ( @cfile ) {
			if ($line =~ /^AllowUsers/) {
				return 1;
			} else {
				next;
			}
		}
		return 0;
	} else {
		return 2;	
	}
}

sub create_gen_config {
	my $krbchk = $_[0];
	if ( $gconfig{'real_os_type'} =~ m/suse/i ) {
		$fconfig="PermitRootLogin yes\n" .
			"HostbasedAuthentication yes\n" .
			"IgnoreUserKnownHosts yes\n" .
			"IgnoreRhosts no\n" .
			"PasswordAuthentication no\n" .
			"UsePAM yes\n" .
			"X11Forwarding yes\n" .
			"Subsystem	sftp	/usr/lib64/ssh/sftp-server\n" .
			"AcceptEnv LANG LC_CTYPE LC_NUMERIC LC_TIME LC_COLLATE LC_MONETARY LC_MESSAGES\n" .  
			"AcceptEnv LC_PAPER LC_NAME LC_ADDRESS LC_TELEPHONE LC_MEASUREMENT\n" . 
			"AcceptEnv LC_IDENTIFICATION LC_ALL\n" .
			"MaxStartups 1000\n";
		if ($krbchk == 1) {
			$fconfig = $fconfig .
			"GSSAPIAuthentication yes\n" .
			"GSSAPICleanupCredentials yes\n";
		}
	} else {
		$fconfig="PermitRootLogin yes\n" .
			"Protocol 2\n" .
			"SyslogFacility AUTHPRIV\n" .
			"StrictModes no\n" .
			"PasswordAuthentication yes\n" .
			"ChallengeResponseAuthentication no\n" .
			"UsePAM yes\n" .
			"AcceptEnv LANG LC_CTYPE LC_NUMERIC LC_TIME LC_COLLATE LC_MONETARY LC_MESSAGES\n" .
			"AcceptEnv LC_PAPER LC_NAME LC_ADDRESS LC_TELEPHONE LC_MEASUREMENT\n" .
			"AcceptEnv LC_IDENTIFICATION LC_ALL\n" .
			"X11Forwarding yes\n" .
			"Subsystem	sftp	/usr/libexec/openssh/sftp-server\n" .
			"MaxStartups 1000\n";
		if ($krbchk == 1) {
			$fconfig = $fconfig .
			"GSSAPIAuthentication yes\n" .
			"GSSAPICleanupCredentials yes\n";
		}
	}	
	open(SFILE, ">/etc/ssh/sshd_config");
	printf SFILE $fconfig;
	close(SFILE);		
}

sub get_gusers() {
	my $gusers=$config{'gusers'};
	chomp($gusers);
	$gusers =~ s/ /\n/g;
	return $gusers;
}

sub get_users() {
        my $users=$config{'users'};
	chomp($users);
	$users =~ s/ /\n/g;
        return $users;
}

sub get_dusers() {
        my $users=$config{'dusers'};
	chomp($users);
	$users =~ s/ /\n/g;
        return $users;
}

sub get_krbstat {
	my $krbstat=$config{'krbsup'};
	chomp($krbstat);
	return $krbstat;
}

sub update_wm_config() {
	my $gusers = $_[0];
	my $users = $_[1];
	my $dusers = $_[2];
	my $krbstat = $_[3];
	
	chomp($gusers);
	chomp($users);
	chomp($dusers);

	$gusers =~ s/\n/ /g;
	$users =~ s/\n/ /g;
	$dusers =~ s/\n/ /g;
	$gusers =~ s/\r//g;
	$users =~ s/\r//g;
	$dusers =~ s/\r//g;

	my $gurec = "gusers=$gusers\n";
	my $urec = "users=$users\n";
	my $durec = "dusers=$dusers\n";
	my $krbrec = "krbsup=$krbstat\n";
	
	open(CFILE, ">$instRoot/etc/sshlock/config") or return 1;
	printf CFILE $gurec;
	printf CFILE $urec;
	printf CFILE $durec;
	printf CFILE $krbrec;
	close(CFILE);
	&init_config();
	return 0;
}

sub restart_sshd {
	system("/sbin/service sshd restart");
	return $?;
}

sub add_deny {
        my $dusers = $_[0];
        chomp($dusers);
        my $ent = "DenyUsers $dusers\n";
        open(SFILE, ">>/etc/ssh/sshd_config");
        printf SFILE $ent;
        close(SFILE);
        my $ret = &restart_sshd();
        return $ret;
}

sub add_lock {
	my $gusrs = $_[0];
	my $usrs=$_[1];
	my $krbcheck = $_[2];
	chomp($gusrs);
	chomp($usrs);
	&create_gen_config($krbcheck);
	$gusrs = $gusrs . " root gpadmin";
	my $ent = "AllowUsers $gusrs $usrs\n";
	open(SFILE, ">>/etc/ssh/sshd_config");
	printf SFILE $ent;
	close(SFILE);
	return;
}

sub rem_lock {
	$krbcheck = $_[0];;
	&create_gen_config($krbcheck);
	return;
}

1;
