BEGIN { push(@INC, ".."); };
use WebminCore;
use DBI;

&init_config();
%access = &get_module_acl();

sub list_tbls {
	my $username=$config{'db_account'};
	my $password=$config{'db_account_pass'};
	my $database=$config{'db_name'};
	my $hostname=$config{'db_hostname'};

	my @tables;

	my $dbh = DBI->connect("dbi:Pg:dbname=$database;host=$hostname;",
                                $username,$password)
                                or return @tables = ("1ERR","Could Not Connect to Database. Make sure the connection string is in module config located in the top left corner of this window");

	my $selsth = $dbh->prepare("SELECT c.relname, u.usename 
                                FROM pg_catalog.pg_class c 
                                LEFT JOIN pg_catalog.pg_user u ON u.usesysid = c.relowner 
                                WHERE substr(relname,1,3)='_t_' or substr(relname,1,3)='_v_'
                                ORDER by 2,1;");
	$selsth->execute();

	while ( my ($tbname,$owner) = $selsth->fetchrow_array ) {
        	push(@tables,"$tbname,$owner");
	}

	$selsth->finish();

	$dbh->disconnect();

	return @tables;
}

sub drop_tbl {
        my $username=$config{'db_account'};
        my $password=$config{'db_account_pass'};
        my $database=$config{'db_name'};
        my $hostname=$config{'db_hostname'};
	my $tbl = $_[0];

	if ( ($tbl =~ /^_t_/) || ($tbl =~ /^_v_/) ) {
		$tblcheck = 0;
	} else {
		$tblcheck = 1;
	}  

	if ( $tblcheck == 0 ) {
        	my $dbh = DBI->connect("dbi:Pg:dbname=$database;host=$hostname;",
                                $username,$password)
                                or die ("Could Not Connect to Database");

		my $dsth;

		if ( $tbl =~ /^_t_/ ) {
			$dsth = "drop external table if exists $tbl";
        	} elsif ( $tbl =~ /^_v_/ ) {
			$dsth = "drop table if exists $tbl";
		}		
		
		my $result = $dbh->do($dsth) or die ("Can't execute $stmt: $dbh->errstr\n");
        	$dbh->disconnect();
		return 0;
	} else {
		return 1;
	}
}

1;
