#!/usr/bin/perl
# edit_group.cgi
# Display a form for editing or creating a group

require './user-lib.pl';
&ReadParse();

# Get group and show page header
$n = $in{'num'};
if ($n eq "") {
	$access{'gcreate'} == 1 || &error($text{'gedit_ecreate'});
	&ui_print_header(undef, $text{'gedit_title2'}, undef, undef, 0, 1, 0);
	}
else {
	@glist = &list_groups();
	%group = %{$glist[$n]};
	&can_edit_group(\%access, \%group) ||
		&error($text{'gedit_eedit'});
	&ui_print_header(undef, $text{'gedit_title'}, undef, undef, 0, 1, 0);
	}
@ulist = &list_users();

&build_group_used(\%gused);

# Start of form
print &ui_form_start("save_group.cgi", "post");
print &ui_hidden("num", $n) if ($n ne "");
print &ui_table_start($text{'gedit_details'}, "width=100%", 2, [ "width=30%" ]);

# Group name
print &ui_table_row($text{'gedit_group'},
	$n eq "" ? &ui_textbox("group", undef, 20)
		 : "<tt>$group{'group'}</tt>");

# Group ID
if ($n ne "") {
	# Existing group, just show field to edit
	$gidfield = "<tt>$group{'gid'}</tt>";
	}
else {
	# Work out which GID modes are available
	@gidmodes = ( );
	$defgid = &allocate_gid(\%gused);
	if ($access{'autogid'}) {
		push(@gidmodes, [ 1, $text{'gedit_gid_def'} ]);
		}
	if ($access{'calcgid'}) {
		push(@gidmodes, [ 2, $text{'gedit_gid_calc'} ]);
		}
	if ($access{'usergid'}) {
		push(@gidmodes, [ 0, &ui_textbox("gid", $defgid, 10) ]);
		}
	if (@gidmodes == 1) {
		$gidfield = &ui_hidden("gid_def", $gidmodes[0]->[0]).
			    $gidmodes[0]->[1];
		}
	else {
		$gidfield = &ui_radio("gid_def", $config{'gid_mode'},
				      \@gidmodes);
		}
	}
print &ui_table_row($text{'gedit_gid'}, $gidfield);

if ( $n ne "" ) {
	print &ui_hidden("gid", $group{'gid'});
}
print &ui_hidden("passmode", "0");

# Member chooser
@ulist = &sort_users(\@ulist, $config{'sort_mode'});
if ($config{'membox'} == 0) {
	# Nicer left/right chooser
	print &ui_table_row($text{'gedit_members'},
		&ui_multi_select("members",
			[ map { [ $_, $_ ] }
			      sort { lc($a) cmp lc($b) }
				   split(/,/ , $group{'members'}) ],
			[ map { [ $_->{'user'}, $_->{'user'} ] } @ulist ],
			10, 1, 0,
			$text{'gedit_allu'}, $text{'gedit_selu'}, 150));
	}
else {
	# Text box
	print &ui_table_row($text{'gedit_members'},
		&ui_textarea("members",
			     join("\n", split(/,/ , $group{'members'})),
			     5, 30));
	}

# Primary members (read-only)
if ($n ne "") {
	@upri = grep { $_->{'gid'} == $group{'gid'} } @ulist;
	if (@upri) {
		@uprilinks = ( );
		foreach $u (@upri) {
			if (&can_edit_user(\%access, $u)) {
				push(@uprilinks, "<a href='edit_user.cgi?".
				  "num=$u->{'num'}'>$u->{'user'}</a>");
				}
			else {
				push(@uprilinks, $u->{'user'});
				}
			}
		$upri = &ui_links_row(\@uprilinks);
		}
	else {
		$upri = $text{'gedit_prinone'};
		}
	print &ui_table_row($text{'gedit_pri'}, $upri, 3);
	}

print &ui_table_end();

# Section for on-change and on-create events
if ($n ne "") {
	$access{'chgid'} = 0; 
	$access{'mothers'} = 0;
	if ($access{'chgid'} == 1 || $access{'mothers'} == 1) {
		print &ui_table_start($text{'onsave'}, "width=100%", 2,
				      [ "width=30%" ]);

		# Change file GIDs on save
		if ($access{'chgid'} == 1) {
			print &ui_table_row(
				$text{'chgid'},
				&ui_radio("chgid", 0,
				  [ [ 0, $text{'no'} ],
				    [ 1, $text{'gedit_homedirs'} ],
				    [ 2, $text{'gedit_allfiles'} ] ]));
			}

		# Update in other modules?
		$access{'mothers'} = 0;
		if ($access{'mothers'} == 1) {
			print &ui_table_row(
				$text{'gedit_mothers'},
				&ui_radio("others", $config{'default_other'},
					  [ [ 1, $text{'yes'} ],
					    [ 0, $text{'no'} ] ]));
			}

		print &ui_table_end();
		}
	}
else {
	$access{'cothers'} = 0;
	if ($access{'cothers'} == 1) {
		print &ui_table_start($text{'uedit_oncreate'}, "width=100%", 2,
				      [ "width=30%" ]);

		# Create in other modules?
		print &ui_table_row(
			$text{'gedit_cothers'},
			&ui_radio("others", $config{'default_other'},
				  [ [ 1, $text{'yes'} ],
				    [ 0, $text{'no'} ] ]));

		print &ui_table_end();
		}
	}

# Save/delete/create buttons
if ($n ne "") {
	print &ui_form_end([
		[ undef, $text{'save'} ],
		$access{'gdelete'} ? ( [ 'delete', $text{'delete'} ] ) : ( ),
		]);
	}
else {
	print &ui_form_end([ [ undef, $text{'create'} ] ]);
	}

&ui_print_footer("index.cgi?mode=groups", $text{'index_return'});

