#!/usr/bin/perl
# edit_user.cgi
# Display a form for editing a user, or creating a new user


require './user-lib.pl';
use Time::Local;
#require 'timelocal.pl';

&ReadParse();

# Show header and get the user
$n = $in{'num'};
if ($n eq "") {
	$access{'ucreate'} || &error($text{'uedit_ecreate'});
	&ui_print_header(undef, $text{'uedit_title2'}, undef, undef, 0, 1, 0);
	}
else {
	@ulist = &list_users();
	%uinfo = %{$ulist[$n]};
	&can_edit_user(\%access, \%uinfo) || &error($text{'uedit_eedit'});
	&ui_print_header(undef, $text{'uedit_title'}, undef, undef, 0, 1, 0);
	}
@tds = ( "width=30%" );

# build list of used shells
%shells = map { $_, 1 } split(/,/, $config{'shells'});
@shlist = ($config{'default_shell'} ? ( $config{'default_shell'} ) : ( ));
push(@shlist, "/bin/sh", "/bin/csh", "/bin/false") if ($shells{'fixed'});
&build_user_used(\%used, $shells{'passwd'} ? \@shlist : undef);
if ($shells{'shells'}) {
	open(SHELLS, "/etc/shells");
	while(<SHELLS>) {
		s/\r|\n//g;
		s/#.*$//;
		push(@shlist, $_) if (/\S/);
		}
	close(SHELLS);
	}

# Start of the form
print &ui_form_start("save_user.cgi", "post");
print &ui_hidden("num", $n) if ($n ne "");
print &ui_hidden("old", $uinfo{'user'}) if ($n ne "");
print &ui_hidden("user", $uinfo{'user'}) if ($n ne "");
print &ui_table_start($text{'uedit_details'}, "width=100%", 2, \@tds);

# Username
if ($n eq "" && $config{'new_user_group'} && $access{'gcreate'}) {
	$onch = "newgid.value = user.value";
	}
if ($access{'urename'} || $n eq "") {
		if ($in{'num'}) {
			print &ui_table_row($text{'user'},
			&ui_textbox("user", $uinfo{'user'}, 40, 1, undef,
			    	"onChange='$onch'"));
		} else {
			print &ui_table_row($text{'user'},
			&ui_textbox("user", $uinfo{'user'}, 40, 0, undef,
			    	"onChange='$onch'"));
		}
	}
else {
	print &ui_table_row($text{'user'},
		"<tt>".&html_escape($uinfo{'user'})."</tt>");
	print &ui_hidden("user", $uinfo{'user'}),"\n";
	}

# User ID
if ($n ne "") {
	# Existing user, just show field to edit
		$uidfield = &ui_textbox("uid", $uinfo{'uid'}, 10,1);
		print &ui_hidden("user", $uinfo{'user'}),"\n";
		print &ui_hidden("uid", $uinfo{'uid'}),"\n";
} else {
	# Work out which UID modes are available
	@uidmodes = ( );
	$defuid = &allocate_uid(\%used);
	if ($access{'autouid'}) {
		push(@uidmodes, [ 1, $text{'uedit_uid_def'} ]);
		}
	if ($access{'calcuid'}) {
		push(@uidmodes, [ 2, $text{'uedit_uid_calc'} ]);
		}
	if ($access{'useruid'}) {
		push(@uidmodes, [ 0, &ui_textbox("uid", $defuid, 10) ]);
		}
	if (@uidmodes == 1) {
		$uidfield = &ui_hidden("uid_def", $uidmodes[0]->[0]).
			    $uidmodes[0]->[1];
		}
	else {
		$uidfield = &ui_radio("uid_def", $config{'uid_mode'},
				      \@uidmodes);
		}
	}
print &ui_table_row($text{'uid'}, $uidfield);

# Real name
if ( $uinfo{'real'} =~ m/<script>/i ) {
        $uinfo{'real'} =~ s/<script>//gi;
        $uinfo{'real'} =~ s/<\/script>//gi;
}

if ($config{'extra_real'}) {
	# Has separate name, office, work and home phone parts
	local @real = split(/,/, $uinfo{'real'}, 5);
	print &ui_table_row($text{'real'},
		&ui_textbox("real", $real[0], 40));

	print &ui_table_row($text{'office'},
		&ui_textbox("office", $real[1], 20));

	print &ui_table_row($text{'workph'},
		&ui_textbox("workph", $real[2], 20));

	print &ui_table_row($text{'homeph'},
		&ui_textbox("homeph", $real[3], 20));

	print &ui_table_row($text{'extra'},
		&ui_textbox("extra", $real[4], 20));
} else {
	# Just a name
	$uinfo{'real'} =~ s/,*$//;	# Strip empty extra fields
		if($in{'num'}) {
			print &ui_table_row($text{'real'},
			&ui_textbox("real", $uinfo{'real'}, 40));
		} else {
			print &ui_table_row($text{'real'},
			&ui_textbox("real", $uinfo{'real'}, 40));
		}	
}

# Show input for home directory
if ($access{'autohome'}) {
	# AUtomatic, cannot be changed
	$homefield = $text{'uedit_auto'}.
		     ($n eq "" ? "" : "( <tt>$uinfo{'home'}</tt>" );
	}
else {
	if ($config{'home_base'}) {
		# Can be automatic
		local $grp = &my_getgrgid($uinfo{'gid'});
		local $hb = $n eq "" ||
			    &auto_home_dir($config{'home_base'},
				    $uinfo{'user'}, $grp) eq $uinfo{'home'};
		if ($in{'num'}) {
			$homefield = &ui_textbox("home", $uinfo{'home'},
				   	40, 1, undef, undef);
			print &ui_hidden("home", $uinfo{'home'})
		} else {
			$homefield = &ui_radio("home_base", $hb ? 1 : 0,
                        [ [ 1, $text{'uedit_auto'}."<br>" ],
                          [ 0, $text{'uedit_manual'}." ".
                               &ui_filebox("home", $hb ? "" : $uinfo{'home'},
                                   40, 0, undef, undef, 1) ] ]);	
		}
	} else {
		# Allow any directory
		$homefield = &ui_filebox("home", $uinfo{'home'}, 25, 0,
					 undef, undef, 1);
		}
	}
print &ui_table_row($text{'home'},
	$homefield);

push(@shlist, $uinfo{'shell'}) if ($n ne "" && $uinfo{'shell'});
if ($access{'shells'} ne "*") {
        # Limit to shells from ACL
        @shlist = $n ne "" ? ($uinfo{'shell'}) : ();
        push(@shlist, split(/\s+/, $access{'shells'}));
        $shells = 1;
}
$shells = 1 if ($access{'noother'});
@shlist = &unique(@shlist);
if ($n ne "" && !$uinfo{'shell'}) {
        push(@shlist, [ "", "&lt;None&gt;" ]);
}
push(@shlist, [ "*", $text{'uedit_other'} ]) if (!$shells);
$firstshell = ref($shlist[0]) ? $shlist[0]->[0] : $shlist[0];
print &ui_table_row($text{'shell'}, 
&ui_select("shell", $n eq "" ? $config{'default_shell'} || $firstshell
	: $uinfo{'shell'},
        \@shlist, 1, 0, 0, 0,
        "onChange='form.othersh.disabled = form.shell.value != \"*\"'").
        ($shells ? "" : &ui_filebox("othersh", undef, 40, 1)));

# Get the password, generate random if needed
$pass = $n ne "" ? $uinfo{'pass'} : $config{'lock_string'};
if ($n eq "" && $config{'random_password'}) {
	$random_password = &generate_random_password();
	}

# Show password field
$passmode = $pass eq "" && $random_password eq "" ? 0 :
	    $pass eq $config{'lock_string'} && $random_password eq "" ? 1 :
	    $random_password ne "" ? 3 :
	    $pass && $pass ne $config{'lock_string'} &&
		$random_password eq "" ? 2 : -1;
$pffunc = $config{'passwd_stars'} ? \&ui_password : \&ui_textbox;
print &ui_table_row($text{'pass'},
	&ui_radio_table("passmode", $passmode,
	  [   [ 0, $config{'empty_mode'} ? $text{'none1'} : $text{'none2'} ],
	      [ 3, $text{'clear'},
	      &$pffunc("pass", $config{'random_password'} && $n eq "" ?
				$random_password : "", 15) ],
	    $access{'nocrypt'} ?
		( [ 2, $text{'nochange'},
		    &ui_hidden("encpass", $pass) ] ) :
		( [ 2, $text{'encrypted'},
		    &ui_textbox("encpass", $passmode == 2 ? $pass : "", 60) ] )
	  ]).
	  ($can_disable ? "&nbsp;&nbsp;".&ui_checkbox("disable", 1,
				$text{'uedit_disabled'}, $disabled) : "")
	  );

print &ui_table_end();

$pft = &passfiles_type();
if (($pft == 2 || $pft == 5) && $access{'peopt'}) {
	# System has a shadow password file as well.. which means it supports
	# password expiry and so on
	print &ui_table_start($text{'uedit_passopts'}, "width=100%", 4, \@tds);

	local $max = $n eq "" ? $config{'default_max'} : $uinfo{'max'};
	print &ui_table_row($text{'change'},
		($uinfo{'change'} ? &make_date(timelocal(
				       gmtime($uinfo{'change'} * 60*60*24)),1) :
		 $n eq "" ? $text{'uedit_never'} :
			    $text{'uedit_unknown'}));

	if ($pft == 2) {
		if ($n eq "") {
			if ($config{'default_expire'} =~
			    /^(\d+)\/(\d+)\/(\d+)$/) {
				$eday = $1;
				$emon = $2;
				$eyear = $3;
				}
			}
		elsif ($uinfo{'expire'}) {
			@tm = localtime(timelocal(gmtime($uinfo{'expire'} *
							 60*60*24)));
			$eday = $tm[3];
			$emon = $tm[4]+1;
			$eyear = $tm[5]+1900;
			}
		print &ui_table_row($text{'expire'},
			&date_input($eday, $emon, $eyear, 'expire'));
	} else {
		print &ui_table_row($text{'ask'},
			&ui_yesno_radio("ask", $uinfo{'change'} eq '0'));
	}

	# Minimum and maximum days for changing
	print &ui_table_row($text{'min'},
		&ui_textbox("min", $n eq "" ? $config{'default_min'} :
					$uinfo{'min'}, 5));

	print &ui_table_row($text{'max'},
		&ui_textbox("max", $n eq "" ? $config{'default_max'} :
					$uinfo{'max'}, 5));

	if ($pft == 2) {
		# Warning and inactive days. Only available when full shadow
		# files are used
		print &ui_table_row($text{'warn'},
			&ui_textbox("warn", $n eq "" ? $config{'default_warn'}
						     : $uinfo{'warn'}, 5));

		print &ui_table_row($text{'inactive'},
			&ui_textbox("inactive", $n eq "" ?
					$config{'default_inactive'} :
					$uinfo{'inactive'}, 5));
		}

	# Force change at next login
	if (($max || $gconfig{'os_type'} =~ /-linux$/ && $gconfig{'real_os_type'} !~ m/suse/i && $in{'num'} ne "") && $pft == 2) {
		print &ui_table_row(
			$text{'uedit_forcechange'},
			&ui_yesno_radio("forcechange", 0));
		}

	print &ui_table_end();
	}
elsif ($pft == 4 && $access{'peopt'}) {
	# System has extra AIX password information
	print &ui_table_start($text{'uedit_passopts'}, "width=100%", 4, \@tds);

	# Last change date and time
	print &ui_table_row($text{'change'},
		($uinfo{'change'} ? &make_date($uinfo{'change'}) :
		 $n eq "" ? $text{'uedit_never'} :
			    $text{'uedit_unknown'}));

	if ($uinfo{'expire'} =~ /^(\d\d)(\d\d)(\d\d)(\d\d)(\d\d)/) {
		$emon = $1;
		$eday = $2;
		$ehour = $3;
		$emin = $4;
		$eyear = $5;
		if ($eyear > 38) {
			$eyear += 1900;
			}
		else {
			$eyear += 2000;
			}
		}
	$emon =~ s/0(\d)/$1/;	# strip leading 0 
	print &ui_table_row($text{'expire'},
		&ui_radio("expire_def", $uinfo{'expire'} eq '' ? 1 :
					$uinfo{'expire'} eq '0' ? 2 : 0,
			  [ [ 1, $text{'uedit_sys'} ],
			    [ 2, $text{'uedit_never'} ],
			    [ 0, &date_input($eday, $emon, $eyear, 'expire').
				 " ".&ui_textbox("expireh", $ehour, 3).
				 "/".&ui_textbox("expiremi", $emin, 3) ] ]), 3);

	# Minimum and maximum ages in weeks
	print &ui_table_row($text{'min_weeks'},
	   &ui_opt_textbox("min", $uinfo{'min'}, 5, $text{'uedit_sys'}), 3);

	print &ui_table_row($text{'max_weeks'},
	    &ui_opt_textbox("max", $uinfo{'max'}, 5, $text{'uedit_sys'}), 3);

	# Warning days
	print &ui_table_row($text{'warn'},
	    &ui_opt_textbox("warn", $uinfo{'warn'}, 5, $text{'uedit_sys'}), 3);

	# AIX-specific flags
	print &ui_table_row($text{'flags'},
		&ui_checkbox("flags", "admin", $text{'uedit_admin'},
			     $uinfo{'admin'})."<br>".
		&ui_checkbox("flags", "admchg", $text{'uedit_admchg'},
			     $uinfo{'admchg'})."<br>".
		&ui_checkbox("flags", "nocheck", $text{'uedit_nocheck'},
			     $uinfo{'nocheck'}), 3);

	print &ui_table_end();
	}


# Group memberships section
print &ui_table_start($text{'uedit_gmem'}, "width=100%", 4, \@tds);

# Primary group
@groupopts = ( );
$gidmode = 0;

if ( $n eq "") {
	push(@groupopts, [ 2, $text{'uedit_samg'} ]);
	push(@groupopts, [ 1, $text{'uedit_newg'},
		&ui_textbox("newgid", undef, 20) ]);
}

$gidmode = $config{'new_user_group'} ? 2 : 0;
local $w = 300;
local $h = 200;
if ($gconfig{'db_sizeuser'}) {
	($w, $h) = split(/x/, $gconfig{'db_sizeuser'});
}

push(@groupopts, [ 0, $text{'uedit_oldg'},
	&ui_textbox("gid", $n eq "" ? $config{'default_group'} :
        scalar(&my_getgrgid($uinfo{'gid'})), 13)." ".
        &popup_window_button("my_group_chooser.cgi?multi=0", $w, $h,
        1, [ [ "ifield", "gid", "group" ] ]) ]);

if ( $n eq "" ) {
	$groupfield = &ui_radio_table("gidmode", $gidmode, \@groupopts);
	print &ui_table_row($text{'group'}, $groupfield, 3);
} else {
	$groupfield = &ui_textbox("gid", $n eq "" ? $config{'default_group'} :
        scalar(&my_getgrgid($uinfo{'gid'})), 13)." ".
        &popup_window_button("my_group_chooser.cgi?multi=0", $w, $h, 
        1, [ [ "ifield", "gid", "group" ] ]);
	print &ui_table_row($text{'group'}, $groupfield, 3);
}

# Secondary Group
@defsecs = &split_quoted_string($config{'default_secs'});
@glist = &list_groups();
@glist = sort { $a->{'group'} cmp $b->{'group'} } @glist
	if ($config{'sort_mode'});

%ingroups = ( );
foreach $g (@glist) {
	@mems = split(/,/ , $g->{'members'});
	$ismem = &indexof($uinfo{'user'}, @mems) >= 0;
	if ($n eq "") {
		$ismem = 1 if (&indexof($g->{'group'}, @defsecs) >= 0);
	}
	$ingroups{$g->{'group'}} = $ismem;
}

@canglist = ( );
foreach $g (@glist) {
	next if (!&can_use_group(\%access, $g->{'group'}) &&
	!$ingroups{$g->{'group'}});
	push(@canglist, [ $g->{'group'}, $g->{'group'} ]);
}

@ingroups = map { [ $_, $_ ] } sort { $a cmp $b }
grep { $ingroups{$_} } (keys %ingroups);
$secfield = &ui_multi_select("sgid", \@ingroups, \@canglist, 5, 1, 0,
	$text{'uedit_allg'}, $text{'uedit_ing'});

print &ui_table_row($text{'uedit_2nd'}, $secfield, 3);
    
print &ui_table_end();

# HPAA Actions and Settings Section

if ($n eq "") {
	print &ui_table_start($text{'uedit_hpaa'}, "width=100%", 2, \@tds);
		print &ui_table_row($text{'uedit_prop_user'}, &ui_yesno_radio("propuser", 0),"",2);
		print &ui_table_row($text{'uedit_gen_key'}, &ui_yesno_radio("genkey", 0),"",2);
		if (($gconfig{'install_typ'} eq 'HPBI') or ($gconfig{'install_typ'} eq 'LGP') or ($gconfig{'install_typ'} eq 'LTD')) {
			print &ui_table_row($text{'uedit_add_skey'}, &ui_yesno_radio("addskey", 0),"",2);
		}
	print &ui_table_end();
} else {
	print &ui_table_start($text{'uedit_hpaa'}, "width=100%", 2, \@tds);
		#print &ui_table_row($text{'uedit_prop_user'}, &ui_yesno_radio("propuser", 0),"",2);
		print &ui_table_row($text{'uedit_gen_key'}, &ui_yesno_radio("genkey", 0),"",2);
		if (($gconfig{'install_typ'} eq 'HPBI') or ($gconfig{'install_typ'} eq 'LGP') or ($gconfig{'install_typ'} eq 'LTD')) {
			print &ui_table_row($text{'uedit_add_skey'}, &ui_yesno_radio("addskey", 0),"",2);
		}
	print &ui_table_end();
}

if ($n eq "") {
	# Creating a user - show options for creating home directory, copying
	# skel files and creating in other modules
	if ($access{'makehome'} == 1 || $access{'copy'} == 1 ||
	    $access{'cothers'} == 1) {
		print &ui_table_start($text{'uedit_oncreate'}, "width=100%",
				      2, \@tds);

		# Create home dir
		if ($access{'makehome'} == 1) {
			print &ui_table_row(
				$text{'uedit_makehome'},
				&ui_yesno_radio("makehome", 1));
			}

		# Copy skel files
		if ($config{'user_files'} =~ /\S/ && $access{'copy'} == 1) {
			print &ui_table_row(
				$text{'uedit_copy'},
				&ui_yesno_radio("copy_files", 1));
			}

		# Create in other modules
		#if ($access{'cothers'} == 1) {
			#print &ui_table_row(
			#	$text{'uedit_cothers'},
			#	&ui_yesno_radio("others",
			#		        $config{'default_other'}));
			#}
			print &ui_hidden("others", "0");

		print &ui_table_end();
		}
	}

if ($n ne "") {
	# Buttons for saving and other actions
	@buts = ( [ undef, $text{'save'} ] );

	# List logins by user
	push(@buts, [ "list", $text{'uedit_logins'} ]);

	# Link to the mailboxes module, if installed
	if (&foreign_available("mailboxes") &&
	    &foreign_installed("mailboxes", 1)) {
		push(@buts, [ "mailboxes", $text{'uedit_mail'} ]);
		}

	# Link to Usermin for switching user
	if (&foreign_available("usermin") &&
	    &foreign_installed("usermin", 1) &&
	    (%uacl = &get_module_acl("usermin") &&
	    $uacl{'sessions'})) {
		# Link to Usermin module for switching to some user
		&foreign_require("usermin", "usermin-lib.pl");
		local %uminiserv;
		&usermin::get_usermin_miniserv_config(\%uminiserv);
		if ($uminiserv{'session'}) {
			push(@buts, [ "switch", $text{'uedit_swit'} ]);
			}
		}

	# Delete user
	if ($access{'udelete'}) {
		push(@buts, [ "delete", $text{'delete'} ]);
		}
	print &ui_form_end(\@buts);
	}
else {
	# Create button
	print &ui_form_end([ [ undef, $text{'create'} ] ]);
	}

&ui_print_footer("index.cgi?mode=users", $text{'index_return'});


