#!/usr/bin/perl
# mass_delete_user.cgi
# Delete multiple users, after asking for confirmation

require './user-lib.pl';
&ReadParse();
%ulist = map { $_->{'user'}, $_ } &list_users();
&error_setup($text{'umass_err'});

if (not defined($in{'confirmed'})) {
	foreach $name (split(/\0/, $in{'d'})) {
		$user = $ulist{$name};
		if ($user) {
			&can_edit_user(\%access, $user) ||
			&error(&text('umass_euser', $name));
		}
		if ($user->{'uid'} < $config{'base_uid'}) {
			&error(&text('lowuid_err', $name));
		}
		push(@dlist, $user);
	}
	@dlist || &error($text{'umass_enone'});
}	


if ($in{'deleteu'} || $in{'delhome'} && $in{'confirmed'} ) {
	# Deleting a bunch of users
	$access{'udelete'} || &error($text{'udel_euser'});

	# Check for deletion of system user
	if (!$config{'delete_root'} && $delete_sys) {
		print "<p> <b>",&text('umass_eroot',
				      $delete_root->{'user'}),"</b> <p>\n";
		&ui_print_footer("", $text{'index_return'});
		exit;
	}

	&ui_print_unbuffered_header(undef, $text{'umass_title'}, "");
	foreach $user (split(/,/, $in{'d'})) {
		# Show username
		print "<b>",&text('umass_doing', $user),"</b><br>\n";
		print "<ul>\n";

		if ($in{'deleteu'}) {
			&sim_delete_user($user,1);
		} elsif ($in{'delhome'}) {
			&sim_delete_user($user,2);
		}
		print "$text{'udel_mdone'}<p>\n";

		&made_changes();
		print "</ul>\n";
		}

my $ent = {
                'AdminUsers'  => $gusers,
                'NormalUsers' => $users
          };


	&webmin_log($text{'log_del'}, $text{'log_users'}, $text{'log_success'},
		    { 'users' =>  $in{'d'} } );

	&ui_print_footer("", $text{'index_return'});
} else {
	# Ask if the user is sure
	&ui_print_header(undef, $text{'umass_title'}, "");
	$in{'d'} =~ s/\0/,/g;
	@hids = ( [ "confirmed", 1 ], 
		  [ "d", $in{'d'}] );
	@buts = ( [ "deleteu", $text{'umass_del1'} ],
			  [ "delhome", $text{'umass_del2'} ] );

	print &ui_confirmation_form(
		"mass_delete_user.cgi",
		&text('umass_sure2'),
		\@hids, \@buts,
		$delete_sys && $delete_sys->{'user'} eq 'root' ?
		   $text{'udel_root'} : "",
		);
				
	&ui_print_footer("", $text{'index_return'});
}
