#!/usr/bin/perl
# edit_ui.cgi
# Edit user interface options

require './webmin-lib.pl';
&ui_print_header(undef, $text{'ui_title'}, "");

print $text{'ui_desc'},"<p>\n";

print &ui_form_start("change_ui.cgi", "post");
print &ui_hidden("feedback", 'support@sas.com');
print &ui_hidden("nofeedbackcc", "2");
print &ui_hidden("height", "400");
print &ui_hidden("width", "400");
print &ui_table_start($text{'ui_header'}, undef, 2);

for($i=0; $i<@cs_names; $i++) {
	$cd = $cs_codes[$i];
	print &ui_table_row($cs_names[$i],
		&ui_opt_textbox($cd, $gconfig{$cd}, 8, $text{'ui_default'},
				$text{'ui_rgb'}), undef, [ "valign=middle","valign=middle" ]);
	}

print &ui_table_row($text{'ui_sysinfo'},
	&ui_select("sysinfo", int($gconfig{'sysinfo'}),
		   [ map { [ $_, $text{'ui_sysinfo'.$_} ] } (0, 1, 4, 2, 3) ]), undef, [ "valign=middle","valign=middle" ]);

print &ui_table_row($text{'ui_hostnamemode'},
	&ui_select("hostnamemode", int($gconfig{'hostnamemode'}),
		   [ map { [ $_, $text{'ui_hnm'.$_} ] } (0 .. 3) ]).
	" ".&ui_textbox("hostnamedisplay", $gconfig{'hostnamedisplay'}, 20), undef, [ "valign=middle","valign=middle" ]);

print &ui_table_row($text{'ui_showlogin'},
	&ui_yesno_radio("showlogin", int($gconfig{'showlogin'})), undef, [ "valign=middle","valign=middle" ]);

print &ui_table_row($text{'ui_showhost'},
	&ui_yesno_radio("showhost", int($gconfig{'showhost'})), undef, [ "valign=middle","valign=middle" ]);

print &ui_table_row($text{'ui_dateformat'},
	&ui_select("dateformat", $gconfig{'dateformat'} || "dd/mon/yyyy",
		   [ map { [ $_, $text{'ui_dateformat_'.$_} ] }
			 @webmin_date_formats ]), undef, [ "valign=middle","valign=middle" ]);

# Dialog box size options
print &ui_table_hr();

foreach $db ("file", "user", "users", "date", "module", "modules") {
	($w, $h) = split(/x/, $gconfig{'db_size'.$db});
	print &ui_table_row($text{'ui_size'.$db},
		&ui_radio("size".$db."_def", $w ? 0 : 1,
			[ [ 1, $text{'default'} ],
			  [ 0, &ui_textbox("size".$db."_w", $w, 4)." X ".
			       &ui_textbox("size".$db."_h", $h, 4) ] ]), undef, [ "valign=middle","valign=middle" ]);
	}

print &ui_table_hr();

@install_types = ('Greenplum','Teradata','HPBI','LGP','LTD','HPRISK');

print &ui_table_row($text{'ui_install_typ'},
        &ui_select("install_typ", $gconfig{'install_typ'} || "HPBI",
                   [ map { [ $_, $text{'ui_install_typ_'.$_} ] }
                         @install_types ]));

print &ui_table_row($text{'ui_hnode_name'},
        &ui_textbox("hnode_name", $gconfig{'hnode_name'} || "", 34));
	
print &ui_table_end();
print &ui_form_end([ [ "save", $text{'save'} ] ]);

&ui_print_footer("", $text{'index_return'});

